<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
FastLeaderElection
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="FastLeaderElection";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Messenger.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/FastLeaderElection.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="FastLeaderElection.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server.quorum</FONT>
<BR>
Class FastLeaderElection</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.quorum.FastLeaderElection</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public class <B>FastLeaderElection</B><DT>extends java.lang.Object<DT>implements <A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></DL>
</PRE>

<P>
Implementation of leader election using TCP. It uses an object of the class
 QuorumCnxManager to manage connections. Otherwise, the algorithm is push-based
 as with the other UDP implementations.

 There are a few parameters that can be tuned to change its behavior. First,
 finalizeWait determines the amount of time to wait until deciding upon a leader.
 This is part of the leader election algorithm.
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Messenger.html" title="class in org.apache.zookeeper.server.quorum">FastLeaderElection.Messenger</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Multi-threaded implementation of message handler.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Notification.html" title="class in org.apache.zookeeper.server.quorum">FastLeaderElection.Notification</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Notifications are messages that let other peers know that
 a given peer has changed its vote, either because it has
 joined leader election or because it learned of another
 peer with higher zxid or same zxid and higher server id</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.ToSend.html" title="class in org.apache.zookeeper.server.quorum">FastLeaderElection.ToSend</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Messages that a peer wants to send to other peers.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#FastLeaderElection(org.apache.zookeeper.server.quorum.QuorumPeer, org.apache.zookeeper.server.quorum.QuorumCnxManager)">FastLeaderElection</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A>&nbsp;self,
                   <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A>&nbsp;manager)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructor of FastLeaderElection.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#checkLeader(java.util.HashMap, long, long)">checkLeader</A></B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;votes,
            long&nbsp;leader,
            long&nbsp;electionEpoch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;In the case there is a leader elected, and a quorum supporting
 this leader, we have to check if the leader has voted and acked
 that it is leading.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#getCnxManager()">getCnxManager</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#getLogicalClock()">getLogicalClock</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the current vlue of the logical clock counter</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#lookForLeader()">lookForLeader</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Starts a new round of leader election.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#ooePredicate(java.util.HashMap, java.util.HashMap, org.apache.zookeeper.server.quorum.FastLeaderElection.Notification)">ooePredicate</A></B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;recv,
             java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;ooe,
             <A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Notification.html" title="class in org.apache.zookeeper.server.quorum">FastLeaderElection.Notification</A>&nbsp;n)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This predicate checks that a leader has been elected.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#shutdown()">shutdown</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#termPredicate(java.util.HashMap, org.apache.zookeeper.server.quorum.Vote)">termPredicate</A></B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;votes,
              <A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&nbsp;vote)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Termination predicate.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.html#totalOrderPredicate(long, long, long, long, long, long)">totalOrderPredicate</A></B>(long&nbsp;newId,
                    long&nbsp;newZxid,
                    long&nbsp;newEpoch,
                    long&nbsp;curId,
                    long&nbsp;curZxid,
                    long&nbsp;curEpoch)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Check if a pair (server id, zxid) succeeds our
 current vote.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="FastLeaderElection(org.apache.zookeeper.server.quorum.QuorumPeer, org.apache.zookeeper.server.quorum.QuorumCnxManager)"><!-- --></A><H3>
FastLeaderElection</H3>
<PRE>
public <B>FastLeaderElection</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A>&nbsp;self,
                          <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A>&nbsp;manager)</PRE>
<DL>
<DD>Constructor of FastLeaderElection. It takes two parameters, one
 is the QuorumPeer object that instantiated this object, and the other
 is the connection manager. Such an object should be created only once
 by each peer during an instance of the ZooKeeper service.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>self</CODE> - QuorumPeer that created this object<DD><CODE>manager</CODE> - Connection manager</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getLogicalClock()"><!-- --></A><H3>
getLogicalClock</H3>
<PRE>
public long <B>getLogicalClock</B>()</PRE>
<DL>
<DD>Returns the current vlue of the logical clock counter
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getCnxManager()"><!-- --></A><H3>
getCnxManager</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager</A> <B>getCnxManager</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="shutdown()"><!-- --></A><H3>
shutdown</H3>
<PRE>
public void <B>shutdown</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html#shutdown()">shutdown</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="totalOrderPredicate(long, long, long, long, long, long)"><!-- --></A><H3>
totalOrderPredicate</H3>
<PRE>
protected boolean <B>totalOrderPredicate</B>(long&nbsp;newId,
                                      long&nbsp;newZxid,
                                      long&nbsp;newEpoch,
                                      long&nbsp;curId,
                                      long&nbsp;curZxid,
                                      long&nbsp;curEpoch)</PRE>
<DL>
<DD>Check if a pair (server id, zxid) succeeds our
 current vote.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>id</CODE> - Server identifier<DD><CODE>zxid</CODE> - Last zxid observed by the issuer of this vote</DL>
</DD>
</DL>
<HR>

<A NAME="termPredicate(java.util.HashMap, org.apache.zookeeper.server.quorum.Vote)"><!-- --></A><H3>
termPredicate</H3>
<PRE>
protected boolean <B>termPredicate</B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;votes,
                                <A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&nbsp;vote)</PRE>
<DL>
<DD>Termination predicate. Given a set of votes, determines if
 have sufficient to declare the end of the election round.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>votes</CODE> - Set of votes<DD><CODE>l</CODE> - Identifier of the vote received last<DD><CODE>zxid</CODE> - zxid of the the vote received last</DL>
</DD>
</DL>
<HR>

<A NAME="checkLeader(java.util.HashMap, long, long)"><!-- --></A><H3>
checkLeader</H3>
<PRE>
protected boolean <B>checkLeader</B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;votes,
                              long&nbsp;leader,
                              long&nbsp;electionEpoch)</PRE>
<DL>
<DD>In the case there is a leader elected, and a quorum supporting
 this leader, we have to check if the leader has voted and acked
 that it is leading. We need this check to avoid that peers keep
 electing over and over a peer that has crashed and it is no
 longer leading.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>votes</CODE> - set of votes<DD><CODE>leader</CODE> - leader id<DD><CODE>electionEpoch</CODE> - epoch id</DL>
</DD>
</DL>
<HR>

<A NAME="ooePredicate(java.util.HashMap, java.util.HashMap, org.apache.zookeeper.server.quorum.FastLeaderElection.Notification)"><!-- --></A><H3>
ooePredicate</H3>
<PRE>
protected boolean <B>ooePredicate</B>(java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;recv,
                               java.util.HashMap&lt;java.lang.Long,<A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A>&gt;&nbsp;ooe,
                               <A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Notification.html" title="class in org.apache.zookeeper.server.quorum">FastLeaderElection.Notification</A>&nbsp;n)</PRE>
<DL>
<DD>This predicate checks that a leader has been elected. It doesn't
 make a lot of sense without context (check lookForLeader) and it
 has been separated for testing purposes.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>recv</CODE> - map of received votes<DD><CODE>ooe</CODE> - map containing out of election votes (LEADING or FOLLOWING)<DD><CODE>n</CODE> - Notification
<DT><B>Returns:</B><DD></DL>
</DD>
</DL>
<HR>

<A NAME="lookForLeader()"><!-- --></A><H3>
lookForLeader</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/Vote.html" title="class in org.apache.zookeeper.server.quorum">Vote</A> <B>lookForLeader</B>()
                   throws java.lang.InterruptedException</PRE>
<DL>
<DD>Starts a new round of leader election. Whenever our QuorumPeer
 changes its state to LOOKING, this method is invoked, and it
 sends notifications to all other peers.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html#lookForLeader()">lookForLeader</A></CODE> in interface <CODE><A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum">Election</A></CODE></DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/Election.html" title="interface in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/FastLeaderElection.Messenger.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/FastLeaderElection.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="FastLeaderElection.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
